
#include "hello.xh"

int main ( void )
{
    Environment ev;
	SOM_InitEnvironment ( & ev );

	//	allocate a Hello object
    Hello *obj = new Hello;
	if ( obj ) {
			
		obj -> sayHello ( & ev );
		
		obj -> _set_msg ( & ev, " <from C++ client: Like a turkey!> " );
	
		obj -> sayHello ( & ev );
	
		obj -> somFree ();
	}

	//	obtain a reference to the class object
	M_Hello *classObj = somNewClassReference ( Hello );
	if ( classObj ) {
		
		//	allocate a Hello object via its metaclass interface
		obj = classObj -> HelloCreate ( & ev, " <from C++ client: Like a frog!> " );
		
		//	the reference to the class object may now be safely
		//	released.  it could just as easily be released at
		//	the end of this block.
		
		somReleaseClassReference ( classObj );
	
		if ( obj ) {
			
			obj -> sayHello ( & ev );
		
			obj -> somFree ();
		}
	}

	SOM_UninitEnvironment ( & ev );
    return 0;
}
